/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.enterprise.wrapper;

import cn.hutool.core.collection.CollUtil;
import org.springblade.common.constant.CommonConstant;
import org.springblade.community.entity.Agency;
import org.springblade.community.feign.IAgencyClient;
import org.springblade.core.mp.support.BaseEntityWrapper;
import org.springblade.core.tool.utils.BeanUtil;
import org.springblade.core.tool.utils.SpringUtil;
import org.springblade.enterprise.entity.EnterpriseDept;
import org.springblade.enterprise.entity.Staff;
import org.springblade.enterprise.feign.IDeptClient;
import org.springblade.enterprise.service.IDeptService;
import org.springblade.enterprise.vo.StaffVO;
import org.springblade.estate.feign.IUserAccessPermissionsClient;
import org.springblade.system.expand.feign.IConfClient;

import java.util.List;
import java.util.Objects;

/**
 * 包装类,返回视图层所需的字段
 *
 * @author BladeX
 * @since 2021-03-30
 */
public class StaffWrapper extends BaseEntityWrapper<Staff, StaffVO>  {

	private static IConfClient confClient;
	private static IDeptService deptService;
	private static IAgencyClient agencyClient;

	static {
		confClient = SpringUtil.getBean(IConfClient.class);
		deptService = SpringUtil.getBean(IDeptService.class);
		agencyClient = SpringUtil.getBean(IAgencyClient.class);
	}
	public static StaffWrapper build() {
		return new StaffWrapper();
 	}

	@Override
	public StaffVO entityVO(Staff staff) {
		StaffVO staffVO = Objects.requireNonNull(BeanUtil.copy(staff, StaffVO.class));
		String faceUrl = confClient.addPrefix(staff.getFaceUrl());
		staffVO.setFaceUrl(faceUrl);
		if(staff.getDeptId() != null){
			EnterpriseDept dept = deptService.getById(staff.getDeptId());
			if(dept != null){
				staffVO.setEnterpriseDeptName(dept.getName());
			}
		}
		Agency agency = agencyClient.getById(staff.getAgencyId());
		if(agency != null){
			staffVO.setAgencyName(agency.getName());
		}
		return staffVO;
	}

}
